<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<%
/****************************************************************************/
/*                                                                          */
/* Program name: JTEAENTINPUT.jsp                                           */
/*                                                                          */
/* Description: Sample JSP file to input the entry data                     */
/*                                                                          */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac WA84                                    */
/*              (C) Copyright IBM Corp. 2001                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-December-2001  JWH  Initial release                            */
/*                                                                          */
/*==========================================================================*/
/* Module Name: JTEAENTINPUT.jsp                                            */
/*==========================================================================*/
%>
<%@ page import="com.ibm.workflow.api.*" %>
<%@ page import="com.ibm.workflow.api.ItemPackage.*" %>
<%@ page import="com.ibm.workflow.servlet.client.*" %>
<%@ page import="com.ibm.workflow.servlet.clientx.wext.*" %>
<jsp:useBean id="context" scope="request"
             type="com.ibm.workflow.servlet.client.RequestContext"/>
<jsp:useBean id="pageController" scope="session"
             class="com.ibm.workflow.servlet.clientx.wext.PageController"
             type="com.ibm.workflow.servlet.clientx.wext.PageController"/>
<jsp:useBean id="reuseData" scope="request"
             class="com.ibm.workflow.servlet.clientx.wext.ReuseData"
             type="com.ibm.workflow.servlet.clientx.wext.ReuseData"/>

<%
    ReadOnlyContainer inData = context.getContainer();
    WorkItem workItem = context.getWorkItem();
    ReadWriteContainer outrwData = workItem.outContainer();
    ReadOnlyContainer outData = outrwData.asReadOnlyContainer();

    pageController.setEventListenerObject(this);
    String tmp = reuseData.getHTMLValue("TmpTarget");
%>
<%!
public String getStringMember(RequestContext context, ReadOnlyContainer input, String name) {
    String val = null;
    try {
      val = context.getMemberValue(input, name, "");
    }
    catch (Exception e) {
    }

    return val;
}

public double getDoubleMember(RequestContext context, ReadOnlyContainer input, String name) {
    String val = null;
    double rtn = 0.0;

    try {
      val = context.getMemberValue(input, name, "0.0");
      rtn = Double.parseDouble(val);
    }
    catch (Exception e) {
    }

    return rtn;
}

public double getDoubleReuse(ReuseData res,  String name) {
    String val = null;
    double rtn = 0.0;

    try {
      val = res.getValue(name);
      rtn = Double.parseDouble(val);
    }
    catch (Exception e) {
    }

    return rtn;
  }

public int getLongMember(RequestContext context, ReadOnlyContainer input, String name) {
    String val = null;
    int rtn = 0;

    try {
      val = context.getMemberValue(input, name, "0");
      rtn = Integer.parseInt(val);
    }
    catch (Exception e) {
    }

    return rtn;
}

public int getLongReuse(ReuseData res, String name) {
    String val = null;
    int rtn = 0;

    try {
      val = res.getValue(name);
      rtn = Integer.parseInt(val);
    }
    catch (Exception e) {
    }

    return rtn;
}
%>

<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<META name="GENERATOR" content="IBM WebSphere Page Designer V3.5.3 for Windows">
<META http-equiv="Content-Style-Type" content="text/css">
<title></title>
</head>
<BODY>
<FORM method="post" action='<%=context.getCommand("checkInWorkItem",workItem.persistentOid())%>'>
<!-- METADATA name="JspWizard" startspan -->Expence Entry#: <%=reuseData.getHTMLValue("TmpTarget")%><BR>
<SCRIPT language="JavaScript">
<!--
// Currency and exchangeRate for the computing conversion
function ExchangeRate() {
    this["NA"] = 0;
    this["USD"] = 1;
    this["DM"] = 0.5;
    this["JPY"] = 0.01;
}

exRate = new ExchangeRate();

function SetToExchangeRate( ff ) {
   crr = ff.value;
   var rate = exRate[crr];

   var f = ff.form;
   for (var i = 0; i < f.length; i++) {
        var t = f.elements[i];
        if (t.name == "ExpenseItems[<%=reuseData.getHTMLValue("TmpTarget")%>].ExchangeRate" ) {
            t.value = rate;
        }
    }
}

function SetToAmount( f ) {
    var la;
    var er;
    var ta;
    for (var i = 0; i < f.length; i++) {
        var t = f.elements[i];
        if (t.name == "ExpenseItems[<%=reuseData.getHTMLValue("TmpTarget")%>].Amount" ) {
            la = t;
        } else if (t.name == "ExpenseItems[<%=reuseData.getHTMLValue("TmpTarget")%>].ExchangeRate" ) {
            er = t;
        } else if (t.name == "ExpenseItems[<%=reuseData.getHTMLValue("TmpTarget")%>].ConvertedAmount" ) {
            ta = t;
        }
    }
    ta.value = la.value * er.value;
}
//-->
</SCRIPT>
<BR>
<TABLE border="1" width="100%">
  <TBODY>
    <TR>
      <TD colspan="2" bgcolor="#cccccc">Description</TD>
      <TD colspan="2"><INPUT type="text" name="ExpenseItems[<%=tmp%>].Description" value="<%=reuseData.getHTMLValue("ExpenseItems["+tmp+"].Description")%>" size="47"></TD>
    </TR>
    <TR>
      <TD colspan="4" height="8"></TD>
    </TR>
    <TR>
      <TD width="25%" height="28" bgcolor="#cccccc">Date</TD>
      <TD width="25%" height="28" bgcolor="#cccccc">Amount</TD>
      <TD width="25%" height="28" bgcolor="#cccccc">Currency</TD>
      <TD width="25%" height="28" bgcolor="#cccccc">Exchange Rate</TD>
    </TR>
    <TR>
      <TD width="125"><INPUT type="text" name="ExpenseItems[<%=tmp%>].ExpenseDate" value="<%=reuseData.getHTMLValue("ExpenseItems["+tmp+"].ExpenseDate")%>" size="21"></TD>
      <TD width="124"><INPUT type="text" name="ExpenseItems[<%=tmp%>].Amount" value='<%=reuseData.getHTMLValue("ExpenseItems["+tmp+"].Amount")%>' size="22" onchange="SetToAmount( this.form);"></TD>
      <TD width="76"> <SELECT size="1" name="ExpenseItems[<%=tmp%>].Currency" onchange="SetToExchangeRate(this);SetToAmount( this.form);">
        <OPTION value="NA" <%=reuseData.getHTMLValue("ExpenseItems["+tmp+"].Currency").equals("NA")? "selected":""%>>-Select Currency-</OPTION>
        <OPTION value="USD" <%=reuseData.getHTMLValue("ExpenseItems["+tmp+"].Currency").equals("USD")? "selected":""%>>USD</OPTION>
        <OPTION value="DM" <%=reuseData.getHTMLValue("ExpenseItems["+tmp+"].Currency").equals("DM")? "selected":""%>>DM</OPTION>
        <OPTION value="JPY" <%=reuseData.getHTMLValue("ExpenseItems["+tmp+"].Currency").equals("JPY")? "selected":""%>>JPY</OPTION>
        </SELECT></TD>
      <TD><INPUT type="text" name="ExpenseItems[<%=tmp%>].ExchangeRate" value='<%=reuseData.getHTMLValue("ExpenseItems["+tmp+"].ExchangeRate")%>' size="20" readonly onchange="SetToAmount( this.form);"></TD>
    </TR>
    <TR>
      <TD colspan="4"></TD>
    </TR>
    <TR>
      <TD colspan="2" bgcolor="#cccccc">Converted Amount</TD>
      <TD colspan="2"><INPUT type="text" name="ExpenseItems[<%=tmp%>].ConvertedAmount" value='<%=reuseData.getHTMLValue("ExpenseItems["+tmp+"].ConvertedAmount")%>' size="24" readonly></TD>
    </TR>
  </TBODY>
</TABLE>
<BR>
<FONT color="#ff0000" size="+2"><%
    String err = reuseData.getValue("ERR");

    if (err != null && !err.equals("")) {
        out.println ( "Error Message: " + err);
    }
%></FONT><br>

<!-- METADATA name="JspWizard" endspan -->

<hr>
<input type="button" name="changePage" value="Set Entry" onClick="javascript:{this.form.action='<%=context.getCommand("x-changePage", workItem.persistentOid(), "&x-pid=1")%>'; this.form.submit(); }">
</FORM>
</BODY>
</html>

<%!
public ResponsePage queryPageChange(RequestContext context, PageController controller, PostedValues values) {
    ReuseData reuseData = controller.getReuseData();
    String desc = values.getParameter("ExpenseItems[" + reuseData.getHTMLValue("TmpTarget") + "].Description");
    if (desc == null)
        desc = reuseData.getValue("ExpenseItems[" + reuseData.getHTMLValue("TmpTarget") + "].Description");
    if (desc != null && desc.length() != 0) {
        reuseData.setValue("ERR", "");
        return null;
    }
    reuseData.setValue("ERR", "Description field is required");
    return new ResponsePage(context, "/programs/JTEAENTINPUT.jsp");
}
%>
